<template>
    <div class="namegenerator">
        <div>
            <h2>{{title}}</h2>
        </div>
        <div class="fading" :class="{ 'large' : name.length > 12     }">
            <transition name="fade">
                <div class="bgimage" v-show="visible" v-on:click="click"
                >
                    <div class="largelogo"
                         style="">
                        <img :src="logo" class="logo">
                        <div class="dreamed-name" :style="{ fontFamily: font }">{{name}}</div>

                    </div>
                    <div class="smalllogo"
                         style="">
                        <img :src="logo">
                        <span class="dreamed-name" :style="{ fontFamily: font }">{{name}}</span>
                    </div>
                </div>
            </transition>
        </div>
        <div class="padding">
            <vue-slide-bar style="width: 100%" :min="0"
                           :max="10" v-model="creativity"/>
        </div>
        <p>
            <slot></slot>
        </p>
    </div>
</template>

<script>
  import axios from '@/../node_modules/axios';
  import NamegeneratorBase from './NamegeneratorBase';

  const logonames = [
    'behance_03.gif',
    'behance_06_B.gif',
    'behance_08_C.gif',
    'behance_10.gif',
    'behance_13_B.gif',
    'behance_21_V.gif',
    'behance_24.gif',
    'behance_26_C.gif',
    'behance_29_S.gif',
    'behance_31.gif',
    'behance_37_B.gif',
    'behance_40_L.gif',
    'behance_43.gif',
    'behance_46_G.gif',
    'behance_48.gif',
    'behance_56.png',
    'behance_58.gif',
    'behance_60.gif',
    'behance_62.gif',
    'behance_65.gif',
  ];

  const fonts = [
    'Ubuntu', 'Abel', 'Cabin', 'Titillium+Web'
  ];

  // Stores a map fom letters to a set of logos
  let letterToLogo = [];
  // Stores those logos which don't have the shape of a letter
  letterToLogo['others'] = [];

  logonames.forEach((item, ix) => {
    if (item.length === 16) {
      const letter = item[11];
      if (!letterToLogo[letter]) {
        letterToLogo[letter] = [];
      }
      letterToLogo[letter].push(ix);
    } else {
      letterToLogo['others'].push(ix);
    }
  });

  export default {
    name: 'Startupnames',
    extends: NamegeneratorBase,
    props: {
      'title': String,
      'url': String,
      'imageHeight': Number,
    },
    data () {
      return {
        'creativity': 5,
        'name': '',
        'visible': false,
        'timer': null,
        'fontId': null,
        'logo': null,
      };
    },
    computed: {
      font () {
        return fonts[this.fontId];
      }
    },
    methods: {
      getLogoForName (name) {
        // Returns a Logo which matches the name of the Startup
        let firstLetter = name[0].toUpperCase();
        let logoset = letterToLogo['others'];
        if (firstLetter in letterToLogo) {
          logoset = letterToLogo[firstLetter];
        }

        return require('../assets/startuplogos/' + logonames[logoset[Math.floor(Math.random() * logoset.length)]]);
      },
      next: async function () {
        this.visible = false;

        // Hack to change the font only when the slide is not visible
        window.setTimeout(() => {
          this.fontId = Math.floor(Math.random() * fonts.length);
        }, 200);

        const temperature = this.creativity / 5 + 0.1;
        const response = await axios.get(process.env.VUE_APP_BASE_URL + `/predict/${this.url}?temperature=${temperature}`);

        this.data = response.data;
        this.name = this.data;
        this.logo = this.getLogoForName(this.name);
        this.visible = true;
      }
    },
  };
</script>

<style lang="scss" scoped>
    @import url('https://fonts.googleapis.com/css?family=Abel|Cabin|Titillium+Web|Ubuntu');

    .fading {
        max-width: 375px;
        height: 326px;
    }

    .bgimage {
        background-image: url(../assets/businesscard.jpg);
        background-size: cover;
        width: 375px;
        height: 305px;
    }

    .large {

        .largelogo .dreamed-name {
            font-size: 21px;
        }

        .smalllogo .dreamed-name {
            font-size: 15px;
        }
    }

    .largelogo {
        transform-style: preserve-3d;
        transform: perspective(2656px) rotateX(58deg) rotateZ(-51deg) translate3d(40px, -15px, -89px);
        display: flex;
        align-items: center;
        align-content: center;
        vertical-align: center;
        justify-content: center;
        width: 217px;
        height: 120px;
        text-align: center;
        flex-direction: column;
    }

    .smalllogo {
        transform-style: preserve-3d;
        transform: perspective(2656px) rotateX(57deg) rotateZ(-53deg) translate3d(243px, 47px, -86px);
        width: 242px;
        height: 136px;

        img {
            display: inline-block;
            width: 25px;
            vertical-align: middle;
            margin: 5px;
        }

        .dreamed-name {
            font-size: 20px;
        }
    }

    .logo {
        display: block;
        height: 45px;
    }

    .dreamed-name {
        opacity: 0.9;
        font-family: Ubuntu, sans-serif;
        font-size: 32px;
        font-weight: bold;
        color: #555;

        &.narrow {
        }
    }
</style>